#!/usr/bin/python

#
# This maintenance script updates the content of the "Orthanc" folder
# to match the latest version of the Orthanc source code.
#

import os
import shutil
import urllib2

PLUGIN_SDK_VERSION = '0.9.1'

SOURCE = '/home/jodogne/Subversion/Orthanc'
TARGET = os.path.join(os.path.dirname(__file__), '..', 'Orthanc')
REPOSITORY = 'https://bitbucket.org/sjodogne/orthanc/raw/Orthanc-%s/Plugins/Include' % PLUGIN_SDK_VERSION

FILES = [
    'Core/ChunkedBuffer.cpp',
    'Core/ChunkedBuffer.h',
    'Core/Enumerations.cpp',
    'Core/Enumerations.h',
    'Core/FileStorage/FilesystemStorage.cpp',
    'Core/FileStorage/FilesystemStorage.h',
    'Core/FileStorage/IStorageArea.h',
    'Core/IDynamicObject.h',
    'Core/ImageFormats/ImageAccessor.cpp',
    'Core/ImageFormats/ImageAccessor.h',
    'Core/ImageFormats/ImageBuffer.cpp',
    'Core/ImageFormats/ImageBuffer.h',
    'Core/ImageFormats/ImageProcessing.cpp',
    'Core/ImageFormats/ImageProcessing.h',
    'Core/ImageFormats/PngReader.cpp',
    'Core/ImageFormats/PngReader.h',
    'Core/ImageFormats/PngWriter.cpp',
    'Core/ImageFormats/PngWriter.h',
    'Core/MultiThreading/SharedMessageQueue.cpp',
    'Core/MultiThreading/SharedMessageQueue.h',
    'Core/OrthancException.cpp',
    'Core/OrthancException.h',
    'Core/PrecompiledHeaders.cpp',
    'Core/PrecompiledHeaders.h',
    'Core/SQLite/Connection.cpp',
    'Core/SQLite/Connection.h',
    'Core/SQLite/FunctionContext.cpp',
    'Core/SQLite/FunctionContext.h',
    'Core/SQLite/IScalarFunction.h',
    'Core/SQLite/ITransaction.h',
    'Core/SQLite/NonCopyable.h',
    'Core/SQLite/OrthancSQLiteException.h',
    'Core/SQLite/Statement.cpp',
    'Core/SQLite/Statement.h',
    'Core/SQLite/StatementId.cpp',
    'Core/SQLite/StatementId.h',
    'Core/SQLite/StatementReference.cpp',
    'Core/SQLite/StatementReference.h',
    'Core/SQLite/Transaction.cpp',
    'Core/SQLite/Transaction.h',
    'Core/Toolbox.cpp',
    'Core/Toolbox.h',
    'Core/Uuid.cpp',
    'Core/Uuid.h',
    'Plugins/Samples/Common/VersionScript.map',
    'Resources/EmbedResources.py',
    'Resources/MinGWToolchain.cmake',
    'Resources/MinGW-W64-Toolchain32.cmake',
    'Resources/MinGW-W64-Toolchain64.cmake',
    'Resources/CMake/AutoGeneratedCode.cmake',
    'Resources/CMake/BoostConfiguration.cmake',
    'Resources/CMake/Compiler.cmake',
    'Resources/CMake/DownloadPackage.cmake',
    'Resources/CMake/GoogleTestConfiguration.cmake',
    'Resources/CMake/JsonCppConfiguration.cmake',
    'Resources/CMake/LibPngConfiguration.cmake',
    'Resources/CMake/SQLiteConfiguration.cmake',
    'Resources/CMake/ZlibConfiguration.cmake',
    'Resources/ThirdParty/base64/base64.h',
    'Resources/ThirdParty/base64/base64.cpp',
    'Resources/ThirdParty/minizip/NOTES',
    'Resources/ThirdParty/minizip/crypt.h',
    'Resources/ThirdParty/minizip/ioapi.c',
    'Resources/ThirdParty/minizip/ioapi.h',
    'Resources/ThirdParty/minizip/zip.c',
    'Resources/ThirdParty/minizip/zip.h',
    'Resources/ThirdParty/VisualStudio/stdint.h',
    'Resources/WindowsResources.py',
    'Resources/WindowsResources.rc',
]

SDK = [
    'orthanc/OrthancCPlugin.h',
]   

for f in FILES:
    source = os.path.join(SOURCE, f)
    target = os.path.join(TARGET, f)
    try:
        os.makedirs(os.path.dirname(target))
    except:
        pass

    shutil.copy(source, target)

for f in SDK:
    source = '%s/%s' % (REPOSITORY, f)
    target = os.path.join(TARGET, 'Sdk-%s' % PLUGIN_SDK_VERSION, f)
    try:
        os.makedirs(os.path.dirname(target))
    except:
        pass

    with open(target, 'w') as g:
        g.write(urllib2.urlopen(source).read())
